Package org.apache.sysds.runtime.meta

## Class MatrixCharacteristics

- java.lang.Object
- - org.apache.sysds.runtime.meta.DataCharacteristics
  - - org.apache.sysds.runtime.meta.MatrixCharacteristics

- All Implemented Interfaces:
    `Serializable`

      public class MatrixCharacteristics
      extends DataCharacteristics

  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MatrixCharacteristics()` |
    `MatrixCharacteristics​(long nr, long nc)` |
    `MatrixCharacteristics​(long nr, long nc, int blen)` |
    `MatrixCharacteristics​(long nr, long nc, int blen, long nnz)` |
    `MatrixCharacteristics​(long nr, long nc, long nnz)` |
    `MatrixCharacteristics​(DataCharacteristics that)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `colsKnown()` |
    `boolean` | `dimsKnown()` |
    `boolean` | `dimsKnown​(boolean includeNnz)` |
    `boolean` | `equalDims​(Object anObject)` |
    `boolean` | `equals​(Object anObject)` |
    `long` | `getCols()` |
    `long` | `getDim​(int i)` |
    `int[]` | `getIntDims()` |
    `long` | `getLength()` |
    `long[]` | `getLongDims()` |
    `long` | `getNonZeros()` |
    `long` | `getNonZerosBound()` |
    `long` | `getNumBlocks()` |
    `long` | `getNumColBlocks()` |
    `int` | `getNumDims()` |
    `long` | `getNumRowBlocks()` |
    `long` | `getRows()` |
    `double` | `getSparsity()` |
    `int` | `hashCode()` |
    `boolean` | `isUltraSparse()` |
    `boolean` | `mightHaveEmptyBlocks()` |
    `boolean` | `nnzKnown()` |
    `boolean` | `rowsKnown()` |
    `DataCharacteristics` | `set​(long nr, long nc, int blen)` |
    `DataCharacteristics` | `set​(long nr, long nc, int blen, long nnz)` |
    `DataCharacteristics` | `set​(DataCharacteristics that)` |
    `DataCharacteristics` | `setCols​(long clen)` |
    `DataCharacteristics` | `setDimension​(long nr, long nc)` |
    `DataCharacteristics` | `setNonZeros​(long nnz)` |
    `DataCharacteristics` | `setNonZerosBound​(long nnz)` |
    `DataCharacteristics` | `setRows​(long rlen)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.apache.sysds.runtime.meta.DataCharacteristics

      `aggregateBinary, aggregateUnary, getBlocksize, getDims, getNumBlocks, isNoEmptyBlocks, reorg, set, set, setBlocksize, setDim, setDims, setNoEmptyBlocks`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### MatrixCharacteristics

          public MatrixCharacteristics()

    - #### MatrixCharacteristics

          public MatrixCharacteristics​(long nr,
                                       long nc)

    - #### MatrixCharacteristics

          public MatrixCharacteristics​(long nr,
                                       long nc,
                                       long nnz)

    - #### MatrixCharacteristics

          public MatrixCharacteristics​(long nr,
                                       long nc,
                                       int blen)

    - #### MatrixCharacteristics

          public MatrixCharacteristics​(long nr,
                                       long nc,
                                       int blen,
                                       long nnz)

    - #### MatrixCharacteristics

          public MatrixCharacteristics​(DataCharacteristics that)

  - ### Method Detail

    - #### set

          public DataCharacteristics set​(long nr,
                                         long nc,
                                         int blen)

      Overrides:
        `set` in class `DataCharacteristics`

    - #### set

          public DataCharacteristics set​(long nr,
                                         long nc,
                                         int blen,
                                         long nnz)

      Overrides:
        `set` in class `DataCharacteristics`

    - #### set

          public DataCharacteristics set​(DataCharacteristics that)

      Overrides:
        `set` in class `DataCharacteristics`

    - #### getRows

          public long getRows()

      Overrides:
        `getRows` in class `DataCharacteristics`

    - #### setRows

          public DataCharacteristics setRows​(long rlen)

      Overrides:
        `setRows` in class `DataCharacteristics`

    - #### getCols

          public long getCols()

      Overrides:
        `getCols` in class `DataCharacteristics`

    - #### setCols

          public DataCharacteristics setCols​(long clen)

      Overrides:
        `setCols` in class `DataCharacteristics`

    - #### getLength

          public long getLength()

      Overrides:
        `getLength` in class `DataCharacteristics`

    - #### getNumBlocks

          public long getNumBlocks()

      Overrides:
        `getNumBlocks` in class `DataCharacteristics`

    - #### getNumRowBlocks

          public long getNumRowBlocks()

      Overrides:
        `getNumRowBlocks` in class `DataCharacteristics`

    - #### getNumColBlocks

          public long getNumColBlocks()

      Overrides:
        `getNumColBlocks` in class `DataCharacteristics`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### setDimension

          public DataCharacteristics setDimension​(long nr,
                                                  long nc)

      Overrides:
        `setDimension` in class `DataCharacteristics`

    - #### getDim

          public long getDim​(int i)

      Overrides:
        `getDim` in class `DataCharacteristics`

    - #### getLongDims

          public long[] getLongDims()

      Overrides:
        `getLongDims` in class `DataCharacteristics`

    - #### getIntDims

          public int[] getIntDims()

      Overrides:
        `getIntDims` in class `DataCharacteristics`

    - #### getNumDims

          public int getNumDims()

      Overrides:
        `getNumDims` in class `DataCharacteristics`

    - #### setNonZeros

          public DataCharacteristics setNonZeros​(long nnz)

      Overrides:
        `setNonZeros` in class `DataCharacteristics`

    - #### getNonZeros

          public long getNonZeros()

      Overrides:
        `getNonZeros` in class `DataCharacteristics`

    - #### setNonZerosBound

          public DataCharacteristics setNonZerosBound​(long nnz)

      Overrides:
        `setNonZerosBound` in class `DataCharacteristics`

    - #### getNonZerosBound

          public long getNonZerosBound()

      Overrides:
        `getNonZerosBound` in class `DataCharacteristics`

    - #### getSparsity

          public double getSparsity()

      Overrides:
        `getSparsity` in class `DataCharacteristics`

    - #### dimsKnown

          public boolean dimsKnown()

      Overrides:
        `dimsKnown` in class `DataCharacteristics`

    - #### dimsKnown

          public boolean dimsKnown​(boolean includeNnz)

      Overrides:
        `dimsKnown` in class `DataCharacteristics`

    - #### rowsKnown

          public boolean rowsKnown()

      Overrides:
        `rowsKnown` in class `DataCharacteristics`

    - #### colsKnown

          public boolean colsKnown()

      Overrides:
        `colsKnown` in class `DataCharacteristics`

    - #### nnzKnown

          public boolean nnzKnown()

      Overrides:
        `nnzKnown` in class `DataCharacteristics`

    - #### isUltraSparse

          public boolean isUltraSparse()

      Overrides:
        `isUltraSparse` in class `DataCharacteristics`

    - #### mightHaveEmptyBlocks

          public boolean mightHaveEmptyBlocks()

      Overrides:
        `mightHaveEmptyBlocks` in class `DataCharacteristics`

    - #### equalDims

          public boolean equalDims​(Object anObject)

      Specified by:
        `equalDims` in class `DataCharacteristics`

    - #### equals

          public boolean equals​(Object anObject)

      Specified by:
        `equals` in class `DataCharacteristics`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `DataCharacteristics`